fpga_interface/fpga_interface/urls.py
from django.contrib import admin
from django.urls import path

from django.conf.urls import url, include


urlpatterns = [
    path('admin/', admin.site.urls),
    path('login/', include(('login.urls', 'login'), namespace='login')),
    path('interface/', include(('interface.urls', 'interface'), namespace='interface')),
    path('output/', include(('output.urls', 'output'), namespace='output')),
]

fpga_interface/interface/urls.py
from django.urls import path
from . import views

app_name = 'interface'
urlpatterns = [
    path('', views.base_view, name="base"),
    path("logout/", views.logout_view, name="logout"),
    path("change_password/", views.change_password, name="changepw"),
    path("cluster_informations/", views.read_cluster_informations, name="clusterinformations"),
    path("connections_informations/", views.get_connections_infomations, name="connectionsinfromations"),
    path("network_settings/set/", views.set_network_params, name="network_set"),
    path("simulation/start/", views.start_simulation, name="simulation_start"),
    path("nestcode/", views.get_nest_code, name="nest_code"),
    path("setCode/", views.set_nest_code, name="set_code"),
]

fpga_interface/login/urls.py
from django.conf.urls import url
from . import views

app_name = 'login'
urlpatterns = [
	url("", views.login_view, name="login"),
]

fpga_interface/interface/models.py
from django.db import models

# Create your models here.

fpga_interface/interface/views.py
from ast import Param
import json
import math
from telnetlib import STATUS

from django.http import HttpResponse
from django.shortcuts import render, redirect
#from django.template import loader
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_safe, require_POST
from django.contrib.auth import logout
from django.urls.base import reverse
from django.contrib.auth.forms import PasswordChangeForm
from django.contrib import messages
from django.contrib.auth import update_session_auth_hash
from django.utils.translation import ugettext as _
from django.contrib.sites.shortcuts import get_current_site

import ctypes as ct
import json
import os
from pathlib import Path, PurePath

import yaml
from io import open as iopen

from interface.validators import validate_settings, validate_request_data, validate_start_message, validate_selected_boards
from django.core.exceptions import ValidationError


FOLDER_PATH = Path.cwd().parents[0] / "textfiles"
SETTINGS_FILE = "config.yaml"
SOURCE_PATH = str(Path.cwd().parents[1])
OUTPUT_PATH = str(Path.cwd().parents[1] / "output")


BOARDS_LIST = []

number_of_time_steps = 0


@login_required
def base_view(request):
    return render(request, "interface/base.html")


@login_required
def change_password(request):
    if request.method == 'POST':
        form = PasswordChangeForm(request.user, request.POST)
        if form.is_valid():
            user = form.save()
            update_session_auth_hash(request, user)
            messages.success(request, _(
                'Your password was successfully updates!'))
            return redirect(reverse("interface:base"))
        else:
            messages.error(request, _('Please correct the error below.'))
    else:
        form = PasswordChangeForm(request.user)
    return render(request, 'interface/password_change.html', {'form': form})


@login_required
def logout_view(request):
    print("Logout!!")
    logout(request)
    return redirect(reverse("login:login"))

def propagator_32(tau_syn, tau, c, h):
    P32_LINEAR = 1 / (2 * c * tau * tau) * h * h * (tau_syn - tau) * math.exp(-h / tau)
    P32_SINGULAR = h / c * math.exp( -h / tau)
    P32 = -tau / (c * (1 - tau / tau_syn)) * math.exp(-h / tau_syn) * (math.exp( h * ( 1 / tau_syn -1 / tau)) -1)

    DEV_P32 = abs(P32 - P32_SINGULAR)

    if(tau == tau_syn or (abs(tau-tau_syn) < 0.1 and DEV_P32 > 2 * abs(P32_LINEAR))):
        return P32_SINGULAR
    else:
        return P32

def write_data_to_configfile(data):

    with open(FOLDER_PATH / SETTINGS_FILE) as configfile:
        configuration = yaml.safe_load(configfile)

    configuration["Scheduler"].update({"Syncs per Timestep": int(data["syncsPerTimeStep"])})
    configuration["Scheduler"].update({"Timestep Limit": int(data["timestepLimit"])})

    number_of_time_steps = int(data["timestepLimit"])
    
    neuron_dict = configuration["Neuron"]

    #Set Params
    neuron_dict.update({"V_thresh": float(data["v_thresh_mv"])})
    neuron_dict.update({"V_reset": float(data["v_reset_mv"])})
    neuron_dict.update({"T_ref": float(data["t_ref_ms"])})
    neuron_dict.update({"P11_exc" : math.exp(float(data["h_ms"])*-1/ float(data["tau_ex_ms"]))})
    neuron_dict.update({"P11_inh" : math.exp(float(data["h_ms"])*-1/ float(data["tau_in_ms"]))})
    neuron_dict.update({"P22" : math.exp(float(data["h_ms"])*-1/ float(data["tau_ms"]))})
    neuron_dict.update({"P20" : float(data["tau_ms"]) / float(data["c_pf"]) * (1.0 - neuron_dict["P22"])})
    neuron_dict.update({"P21_exc" : propagator_32(float(data["tau_ex_ms"]), float(data["tau_ms"]), float(data["c_pf"]), float(data["h_ms"]))})
    neuron_dict.update({"P21_inh" : propagator_32(float(data["tau_in_ms"]), float(data["tau_ms"]), float(data["c_pf"]), float(data["h_ms"]))})
    neuron_dict.update({"Exc Weight Decimal Places": int(data["weightFracExc"])})
    neuron_dict.update({"Inh Weight Decimal Places": int(data["weightFracInh"])})
    

    configuration["Neuron"].update(neuron_dict)

    with iopen(FOLDER_PATH / SETTINGS_FILE, "w", encoding="utf-8") as out:
        yaml.dump(configuration, out, default_flow_style=False, sort_keys=False, allow_unicode=True)

@login_required
@require_POST
def set_network_params(request):
        request_data = json.loads(request.body.decode("utf-8"))

        #Validate Data
        try:
            validate_request_data(request_data)
        except ValidationError as e:
            print(e)
            return HttpResponse(e.message, status=400)
        try:
            for element in request_data:
                validate_settings(request_data[element], element)
        except ValidationError as e:
            print(e.message)
            return HttpResponse(e.message, status=400)
        try:
            validate_selected_boards(request_data["Boards"], BOARDS_LIST)
        except ValidationError as e:
            print(e.message)
            return HttpResponse(e.message, status=400)

        write_data_to_configfile(request_data)
        print("Write settings to configfile.")

        initCluster(request_data["Boards"])
            
        return HttpResponse("set_parameters", status=200)

def get_surounding_boards(board_list):
    first_board = board_list[0]
    last_board = board_list[-1]

    ret = []

    for index, row in enumerate(BOARDS_LIST):
        if first_board in row:
            for j, element in enumerate(row):
                if element == first_board:
                    top_left_corner = (index, j)

        if last_board in row:
            for j, element in enumerate(row):
                if element == last_board:
                    bottom_right_corner = (index, j)

    if top_left_corner[0] == 0 and top_left_corner[1] == 0 and bottom_right_corner[0]+1 == len(BOARDS_LIST) and bottom_right_corner[1]+1 == len(BOARDS_LIST[0]) :
        return [];
    
    cur_pos = bottom_right_corner[0]

    if len(BOARDS_LIST)-(bottom_right_corner[0]+1-top_left_corner[0]) == 1:
        ret.extend(BOARDS_LIST[top_left_corner[0]-1][top_left_corner[1]:bottom_right_corner[1]+1])
    elif len(BOARDS_LIST)-(bottom_right_corner[0]+1-top_left_corner[0]) > 1:
        ret.extend(BOARDS_LIST[top_left_corner[0]-1][top_left_corner[1]:bottom_right_corner[1]+1])

        if(bottom_right_corner[0]+1 == len(BOARDS_LIST)):
            cur_pos = -1;
        ret.extend(BOARDS_LIST[cur_pos+1][top_left_corner[1]:bottom_right_corner[1]+1])

    cur_pos = bottom_right_corner[1]
    if len(BOARDS_LIST[0])-(bottom_right_corner[1]+1-top_left_corner[1]) == 1:
        ret.extend([r[top_left_corner[1]-1] for r in BOARDS_LIST[top_left_corner[0]: bottom_right_corner[0]+1]])
    elif len(BOARDS_LIST[0])-(bottom_right_corner[1]+1-top_left_corner[1]) > 1:
        ret.extend([r[top_left_corner[1]-1] for r in BOARDS_LIST[top_left_corner[0]: bottom_right_corner[0]+1]])

        if(bottom_right_corner[1]+1 == len(BOARDS_LIST[0])):
            cur_pos = -1

        ret.extend([r[cur_pos+1] for r in BOARDS_LIST[top_left_corner[0]: bottom_right_corner[0]+1]])

    #print(ret)
    return ret

def initCluster(boardList):
    #print(f"{Path.cwd().parents[1]=}")
    #print("Boards: {}".format(boardList))
    #source_path = str(Path.cwd().parents[1])

    row = None
    for l in BOARDS_LIST:
        if boardList[-1] in l:
            row = l
            break

    for element in row:
        if element in boardList:
            main_node = element
            break


    surrounding_boards = get_surounding_boards(boardList)
    
    boards = "{} {}".format(" ".join(boardList), " ".join(surrounding_boards))
    command = " ".join(["cd", SOURCE_PATH, "&&" , "./fpga.sh --targets", boards, "--program develop"])
    print(command)
    #os.popen(command)
    command = " ".join(["cd", SOURCE_PATH, "&&", "./fpga.sh --targets", " ".join(boardList), "--upload embedded"])
    print(command)
    #os.popen(command)
    command = " ".join(["cd", SOURCE_PATH, "&&", "export TARGET="+main_node])
    print(command)
    #os.popen(command)

    # command = " ".join(["cd", SOURCE_PATH, "&&", "./fpga.sh --targets", boards, "--program develop", "&&", "./fpga.sh --targets", " ".join(boardList), "--upload embedded", "&&" , "export TARGET="+main_node, "&&"])



@login_required
@require_POST
def start_simulation(request):
    message = request.body.decode("utf-8")
    try:
        validate_start_message(message)
    except ValidationError:
        return HttpResponse("incorrect startmessage", status=400)

    command = " ".join(["cd", SOURCE_PATH, "&&", "./sim", str(number_of_time_steps), "src/sw/examples/n_rand_neurons.py --neurons 32 --init"])
    print(command)
    #os.popen(command)

    #calculate_metrics()
    #return HttpResponse(True, status=200)
    url = "http://{0}{1}".format(get_current_site(request), reverse("output:output"));
    return HttpResponse(url, status=200)

def get_files_from_folder(folder, file_prefix, file_suffix):
    file_list = os.listdir(folder)
    data_list = []
    for element in file_list:
        if element.startswith(file_prefix) and element.endswith(file_suffix):
            data_list.append(str(PurePath.as_posix(FOLDER_PATH / "output" / element)))
    return data_list

def calculate_metrics():
    file_list = get_files_from_folder(FOLDER_PATH / "output", "read_spikes_node", "bin")
    command = "cd \"{}\" & merger.exe".format(str(PurePath.as_posix(FOLDER_PATH/ "programs")))

    cur_path = Path.cwd();

    for file in file_list:
        command += " \"{}\"".format(file)
    command += " -o \"{}\"".format(str(PurePath.as_posix(FOLDER_PATH / "output")))

    command += " & cd \"{}\"".format(str(PurePath.as_posix(cur_path)))
    print(command)

    res = os.popen(command)
    print(res.read())

    #print("NumFiles: {0}, Files: {1}".format(num_files, file_str));


    library_path = FOLDER_PATH / "programs" / "createMetrics.so"
    __creater = ct.CDLL(str(library_path))
    __creater.create.restype = ct.c_int

fpga_interface/interface/templates/interface/base.html
{% load static %}

<!doctype html>
<html lang="en">

<head>
    <title>FPGA-Interface Interface</title>
    <meta charset="UTF-8">
    <meta name="author" content="Joachim Reif">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <script type="text/javascript" src="{% static 'interface/plugin/codemirror/lib/codemirror.js' %}"></script>
    <script type="text/javascript" src="{% static 'interface/plugin/codemirror/mode/python/python.js' %}"></script>
    <link rel="stylesheet" type="text/css" href="{% static 'interface/plugin/codemirror/lib/codemirror.css' %}">
    <link rel="stylesheet" type="text/css" href="{% static 'interface/plugin/codemirror/theme/eclipse.css' %}">

    <link rel="stylesheet" href="{% static 'interface/better_style.css' %}" type="text/css">
    <script src="{% static 'interface/script.js' %}" type="module"></script>
    <script src="https://ajax.aspnetcdn.com/ajax/jQuery/jquery-3.6.0.js" type="text/javascript"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/3.7.0/chart.min.js" type="text/javascript"></script>

    <link rel="icon" href="data:;base64,iVBORw0KGgo="> <!-- prevent calling for an favicon-->
</head>

<body>
    <header class="first-level">
        <h1>FPGA-Cluster</h1>
    </header>

    <!-- Elements for settings-->
    <input type="checkbox" id="cb-settings" value="Settings">
    <label for="cb-settings">S</label>
    <aside id="setting">
        <ul>
            <li>
                <button type="button" class="button-sidepanel" id="bt_save_profile" >save Profile</button>
            </li>
            <li>
                <button type="button" class="button-sidepanel" id="bt_load_profile">load Profile</button>
            </li>
            <li>
                <button type="button" class="button-sidepanel" id="bt_console">Console</button>
            </li>
            <li>
                <form>
                    <button type="submit" class="button-sidepanel" formaction="{% url 'interface:changepw' %}">Change Password</button>
                </form>
            </li>
            <li>
                <form>
                    <button type="submit" class="button-sidepanel" formaction="{% url 'interface:logout' %}">Logout</button>
                </form>
            </li>
        </ul> 
    </aside>

    <div id="parameters" class="first-level">
        {% csrf_token %}
        <form action="." id="fo_network">
            <div id="params-first">
                <label for="tau-ms">Tau_ms:</label>
                <input type="number" id="tau-ms" value="10.0">
                <br>
                <label for="c-pf">C_pF:</label>
                <input type="number" id="c-pf" value="250.0">
                <br>
                <label for="t-ref-ms">t_ref_ms:</label>
                <input type="number" id="t-ref-ms" value="2.0">
                <br>
                <label for="v-reset-mv">V_reset_mV:</label>
                <input type="number" id="v-reset-mv" value="-70.0">
                <br>
                <label for="v-thresh-mv">V_thresh_mV:</label>
                <input type="number" id="v-thresh-mv" value="10.0">
                <br>
                <label for="tau-ex-ms">tau_ex_ms:</label>                         
                <input type="number" id="tau-ex-ms" value="2.0">
            </div>
            <div id="params-second">
                <label for="tau-in-ms">tau_in_ms:</label>
                <input type="number" id="tau-in-ms" value="2.0">
                <br>
                <label for="h-ms">h_ms:</label>
                <input type="number" id="h-ms" value="0.1">
                <br>
                <label for="weight-frac-exc">weightFracExc:</label>
                <input type="number" id="weight-frac-exc" value="16">
                <br>
                <label for="weight-frac-inh">weightFracInh:</label>
                <input type="number" id="weight-frac-inh" value="16">
                <br>
                <label for="syncs-per-time-step">syncsPerTimeStep:</label>
                <input type="number" id="syncs-per-time-step" value="3">
                <br>
                <label for="timestep-limit">Number of TimeSteps:</label>
                <input type="number" id="timestep-limit" value="0">
            </div>                
        </form>

        <button id="toggle-editor">Open Editor</button>
    </div>
    
    <div id="graph" class="first-level">
        <canvas width="49vw" height="20vh" id="cv_graph">

        </canvas>
        <div id="console_output">
            <h4>Hier werden Ausgabedaten stehen.</h4>
        </div>
    </div>

    <div id="editor" class="first-level">
        <textarea name="editro" id="codemirror-textarea" ></textarea>
        <button id="save-editor">Save</button>
        <button id="cancel-editor">Cancel</button>
    </div>"

    <div id="matrix" class="first-level">
        <p>i</p>
        <span class="tooltiptext" id="cluster-tooltip">The matrix represent the FPGA-Cluster. By clicking on the green squares you can select boards for your simulation. Selected squares are yellow. You can remove a selection with a second click.</span>
        <!-- Contains the cluster-structure which is created in JavaScript -->
    </div>

    <aside id="errorInformations">
        <table>
            <thead>
                <tr>
                    <td>Source</td>
                    <td id="info-source"></td>
                </tr>
                <tr>
                    <td>Target</td>
                    <td id="info-target"></td>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>Delivered</td>
                    <td id="info-delivered"></td>
                </tr>
                <tr>
                    <td>CRC-Error</td>
                    <td id="info-crcerror"></td>
                </tr>
                <tr>
                    <td>Dropped</td>
                    <td id="info-dropped"></td>
                </tr>
                <tr>
                    <td>Wrong-ID</td>
                    <td id="info-wrongid"></td>
                </tr>
            </tbody>
        </table>
    
        <button class="button-sidepanel">Close</button>
    </aside>

    <footer class="first-level">
        <div class="progress-bar" data-label="" style="--width:0"></div>
        <button id="start">Start simulation</button>
    </footer>
</body>

</html>

fpga_interface/interface/templates/interface/password_change.html
{% load static %}

<!doctype html>

<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Changing Password</title>
    <meta name="author" content="Joachim Reif">
</head>

<body>
    <header>
        <h1>FPGA-Cluster</h1>
    <header>

    <main>
        <form method="POST">
            {% csrf_token %}
            {{ form }}
            <button type="submit">Confirm</button>
        </form>
    </main>
</body>

</html>